"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantStats(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "genotypesCount",
        "genotypesFreq",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import opencb as opencb_1_3_0

        return {
            "hw": opencb_1_3_0.VariantHardyWeinbergStats,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import opencb as opencb_1_3_0

        return {
            "variantType": opencb_1_3_0.VariantType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.variant.avro.VariantHardyWeinbergStats": opencb_1_3_0.VariantHardyWeinbergStats,
            "org.opencb.biodata.models.variant.avro.VariantType": opencb_1_3_0.VariantType,
            "org.opencb.biodata.models.variant.avro.VariantStats": opencb_1_3_0.VariantStats,
        }

    __slots__ = [
        "genotypesCount",
        "genotypesFreq",
        "altAllele",
        "altAlleleCount",
        "altAlleleFreq",
        "casesPercentDominant",
        "casesPercentRecessive",
        "controlsPercentDominant",
        "controlsPercentRecessive",
        "hw",
        "maf",
        "mafAllele",
        "mendelianErrors",
        "mgf",
        "mgfGenotype",
        "missingAlleles",
        "missingGenotypes",
        "numSamples",
        "passedFilters",
        "quality",
        "refAllele",
        "refAlleleCount",
        "refAlleleFreq",
        "variantType",
    ]

    def __init__(
        self,
        genotypesCount,
        genotypesFreq,
        altAllele=None,
        altAlleleCount=None,
        altAlleleFreq=None,
        casesPercentDominant=None,
        casesPercentRecessive=None,
        controlsPercentDominant=None,
        controlsPercentRecessive=None,
        hw=None,
        maf=None,
        mafAllele=None,
        mendelianErrors=None,
        mgf=None,
        mgfGenotype=None,
        missingAlleles=None,
        missingGenotypes=None,
        numSamples=None,
        passedFilters=None,
        quality=None,
        refAllele=None,
        refAlleleCount=None,
        refAlleleFreq=None,
        variantType=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.VariantStats model.

        :param genotypesCount:
        :type genotypesCount: dict[str, int]
        :param genotypesFreq:
        :type genotypesFreq: dict[str, float]
        :param altAllele:
        :type altAllele: None | str
        :param altAlleleCount:
        :type altAlleleCount: None | int
        :param altAlleleFreq:
        :type altAlleleFreq: None | float
        :param casesPercentDominant:
        :type casesPercentDominant: None | float
        :param casesPercentRecessive:
        :type casesPercentRecessive: None | float
        :param controlsPercentDominant:
        :type controlsPercentDominant: None | float
        :param controlsPercentRecessive:
        :type controlsPercentRecessive: None | float
        :param hw:
        :type hw: None | VariantHardyWeinbergStats
        :param maf:
        :type maf: None | float
        :param mafAllele:
        :type mafAllele: None | str
        :param mendelianErrors:
        :type mendelianErrors: None | int
        :param mgf:
        :type mgf: None | float
        :param mgfGenotype:
        :type mgfGenotype: None | str
        :param missingAlleles:
        :type missingAlleles: None | int
        :param missingGenotypes:
        :type missingGenotypes: None | int
        :param numSamples:
        :type numSamples: None | int
        :param passedFilters:
        :type passedFilters: None | boolean
        :param quality:
        :type quality: None | float
        :param refAllele:
        :type refAllele: None | str
        :param refAlleleCount:
        :type refAlleleCount: None | int
        :param refAlleleFreq:
        :type refAlleleFreq: None | float
        :param variantType:
        :type variantType: None | VariantType
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
